
## Data input
ff.ten = read.csv("C:/Research/Empirical/FF-ten.csv", header=T)[,-1]
ff.ten.test = 0.01 * as.matrix(ff.ten[511:nrow(ff.ten),])
ff.ten = ff.ten[1:510,]
ff.ten = 0.01 * ff.ten
ff.ten = data.frame(ff.ten)
n = ncol(ff.ten)

## CC Garch package
#library(ccgarch)

#dcc.para = c(0.01,0.98)
#dcc.results = dcc.estimation(inia = rep(0.01, n), iniA = diag(n), iniB = diag(n), 
#				     ini.dcc=dcc.para, dvar = ff.ten, model="diagonal")


## RM Garch package
library(rmgarch)
library(mvtnorm)

garch11.spec = ugarchspec(mean.model = list(armaOrder = c(0,0)),
				  variance.model = list(garchOrder = c(1,1),
				  model = "sGARCH"),
				  distribution.model = "norm")

dcc.garch11.spec = dccspec(uspec = multispec( replicate(n,garch11.spec) ), dccOrder = c(1,1), distribution = "mvnorm")

w    = rep(1/n, n)
LC   = NULL
LP   = NULL
disc = NULL

i = 1
start = proc.time()
while(i <= 36)
{
	dcc.fit  = dccfit(dcc.garch11.spec, ff.ten)
	dcc.fcst = dccforecast(dcc.fit, n.ahead=1)

	Sig = as.matrix(data.frame((dcc.fcst@mforecast)$H))
	mu  = as.matrix(data.frame((dcc.fcst@mforecast)$mu))
	mu  = as.vector(mu)
	
	y.p  = as.vector(ff.ten.test[i,])
	LP   = c(LP, dmvnorm(y.p, mu, Sig, log=TRUE))
	LC   = c(LC, dnorm(t(w) %*% y.p, t(w) %*% mu, sd = sqrt(t(w) %*% Sig %*% w), log=TRUE))

	ff.ten = rbind(ff.ten, y.p)
	i = i+1
}

sum(LP)
sum(LC)

proc.time() - start








